import specialTypeObj from '../util/SpecialType'
class RuntimeIns {
  constructor() {
    this.objectIdMap = new Map()
    this.index = 0
    this.itemObj = null
    this.objId = 0 // object_id
  }

  setItem(obj) {
    this.clear()
    this.index++
    this.objectIdMap.set(this.index, obj)
    return this.index
  }

  getItem(i) {
    let arr = i.split('_')
    const item = this.objectIdMap.get(parseInt(arr[0]))
    this.getObjectById(item, i)
    return this.itemObj
  }

  getObjectById(obj, id) {
    if (obj && obj. __objectId__ && obj.__objectId__ === id) {
      this.itemObj = obj
      return
    }
    const isSpecialType = specialTypeObj.getSpecialType(obj)
    if (isSpecialType) {
      obj.forEach((element, key) => {
        if (this.getMapObjectById(key, element, id)) {
          return null
        }
      })
    } else {
      for (const key in obj) {
        if (Object.hasOwnProperty.call(obj, key)) {
          const element = obj[key];
          if (this.getMapObjectById(key, element, id)) {
            return
          }
        }
      }
    }
  }

  getMapObjectById (key, element, id) {
    if (key === '__objectId__' && element === id) {
      this.itemObj = element
      return true
    }
    if (typeof element === 'object') {
      if (element.__objectId__ === id) {
        this.itemObj = element
        return true
      } else {
        this.getObjectById(element, id)
      }
    }
    return false
  }

  setObjectId (obj, sId) {
    const isSpecialType = specialTypeObj.getSpecialType(obj)
    if (isSpecialType && obj.forEach) {
      obj.forEach((element, key) => {
        this.updateKey(obj, key, element, sId, isSpecialType)
      })
    } else {
      for (const key in obj) {
        if (Object.hasOwnProperty.call(obj, key)) {
          const element = obj[key];
          this.updateKey(obj, key, element, sId, 'obj')
        }
      }
    }
  }

  updateKey (obj, key, element, sId, type) {
    // if (obj[key] instanceof Set || obj[key] instanceof Map) {  //mark 先简单处理一下数组类型的结构
    //   if (type === 'Map') {
    //     obj.set(key, Array.from(obj[key]))
    //   } else {
    //     obj[key] = Array.from(obj[key])
    //   }
    // }
    this.objId++
    if (element === null) {
    } else if (element instanceof RegExp) {
      if (type === 'Map' || type === 'Set') {
        obj.set(key, element.toString())
      } else {
        obj[key] = element.toString()
      }
    } else if (element instanceof Date) {
      if (type === 'Map' || type === 'Set') {
        obj.set(key, element.toString())
      } else {
        obj[key] = element.toString()
      }
    } else if (typeof element === 'object') {
      // this.setObjectId(element, sId)
      if (type === 'Map' || type === 'Set') {
        element.__objectId__ = sId + '_' + this.objId
      } else {
        obj[key].__objectId__ = sId + '_' + this.objId
      }
    }
  }

  // 容错处理，但意味着消耗更多的内存
  setItemObjectId (id, obj) {
    if (!id) {
      const itemId = this.setItem(obj)
      obj.__objectId__ = `${itemId}_0`
      id = obj.__objectId__
    } else {
      this.getItem(id)
      if (this.itemObj === null) {
        this.setItemObjectId(undefined, obj)
      }
    }
    return id
  }

  clear () {
    if (this.objectIdMap.size < 1000) {
      return
    }
    let index = 0
    this.objectIdMap.forEach((val, key) => {
      if (index > 500) {
        this.objectIdMap.delete(key)
        index++
        return null
      }
    })
  }
}

export default RuntimeIns
