import util from './index'

let runtime = null
function init (run) {
  if (!util.isIOS) {
    return
  }
  runtime = run
  window.finclip_debug_callbacks = []
  // rewriteSetTimeout()
  // rewriteSetInterval()
}

function rewriteSetTimeout () {
  const oldSetTimeOut = window.setTimeout
  window.setTimeout = function (cb, time) {
    oldSetTimeOut(() => {
      saveCallback()
    }, time)
  }
}

function rewriteSetInterval () {
  const oldSetInterval = window.setInterval
  window.setInterval = function (cb, time) {
    oldSetInterval(() => {
      saveCallback(cb)
    }, time)
  }
}

function saveCallback (cb) {
  if (runtime && runtime.status) {
    window.finclip_debug_callbacks.push(cb)
  } else {
    cb()
  }
}

function executeCallback () {
  const cbs = window.finclip_debug_callbacks || []
  for (let index = 0; index < cbs.length; index++) {
    const element = cbs[index]
    element()
  }
}

export default {
  init: init,
  executeCallback: executeCallback
}
