let _hlightNodeContainer = null
function show (dom) {
  initHighlightNode()
  updateHighlightNode(dom)
}

function initHighlightNode () {
  if (_hlightNodeContainer === null) {
    _hlightNodeContainer = document.createElement('div')
    _hlightNodeContainer.style.position = 'fixed'
    _hlightNodeContainer.style.zIndex = '1000000'
    _hlightNodeContainer.style.backgroundColor = 'rgb(38 220 128 / 20%)'
    document.body.append(_hlightNodeContainer)
  }
}

function updateHighlightNode(node) {
  const rect = node.getBoundingClientRect()
  _hlightNodeContainer.style.width = (rect.right - rect.left) + 'px'
  _hlightNodeContainer.style.height = (rect.bottom - rect.top) + 'px'
  _hlightNodeContainer.style.top = node.offsetTop + 'px'
  _hlightNodeContainer.style.left = node.offsetLeft + 'px'
}

function hide () {
  _hlightNodeContainer.style.width = '0px'
  _hlightNodeContainer.style.height = '0px'
  _hlightNodeContainer.style.top = '0px'
}

export default {
  show: show,
  hide: hide
}
